
<?

global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class AnswerMeta{

  var $id_;
  var $question_id_;
  var $user_id_;
  var $date_;
  var $time_;
  var $answer_;

  var $table_;
  var $pid_;
  var $names_;
  var $broker_;

  function AnswerMeta() {
    $this->table_ = "answers";
    $this->pid_ = "id";
    $this->names_[$this->pid_] = "int";    
    $this->names_["question_id"] = "int";
    $this->names_["user_id"] = "int";
    $this->names_["datee"] = "date";
    $this->names_["time"] = "time";
    $this->names_["answer"] = "text";
    $this->broker_ = new Broker($this->table_,$this->pid_,$this->names_);
  }

  function set($id,$question_id,$user_id,$date,$time,$answer) {
    $this->id_ = $id;
    $this->question_id_ = $question_id;
    $this->user_id_ = $user_id;
    $this->date_ = $date;
    $this->time_ = $time;
    $this->answer_ = $answer;
  }  

  function get($question_id,$user_id,$date,$time,$answer) {
    $values["question_id"] = $question_id;
    $values["user_id"] = $user_id;
    $values["datee"] = $date;
    $values["time"] = $time;
    $values["answer"] = $answer;
    return $values;
  } 


  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($id) {
    $is = $this->broker_->is($id);
    return $is;
  } 


  //```````````````````````
  // BROKER
  //```````````````````````

  function load($id) {
    $this->broker_->load($id);
    $ans = $this->broker_->get();
    if (!empty($ans)) {    
      $this->set($id,$ans["question_id"],$ans["user_id"],$ans["datee"],$ans["time"],$ans["answer"]);
    }
    $id = (!empty($ans)) ? $ans["id"] : false;
    return $id;
  }

  function save($question_id,$user_id,$date,$time,$answer) {

    $question_meta = new QuestionMeta();
    
    $isQuestion = $question_meta->is($question_id);
    $isAnswered = $answer != "";

    $broker = $this->broker_;
    $values = $this->get($question_id,$user_id,$date,$time,$answer);
    $answer_id = $isQuestion ? $broker->save($values) : false;

    if ($isQuestion && $isAnswered) {
      $question = new Question($question_id);
      $isRank = $question->type_ == "rank";
      $isCheckbox = $question->type_ == "checkbox";

      if ($isRank) {
        $this->saveRank($answer_id,$user_id,$question_id,$answer);
      } else if ($isCheckbox) {
        $this->saveCheckbox($answer_id,$user_id,$question_id,$answer);
      }
    }
     
    return $answer_id;
  }

  function update($id,$question_id,$user_id,$date,$time,$answer){

    $question_meta = new QuestionMeta();
    $broker = $this->broker_;
    $values = $this->get($question_id,$user_id,$date,$time,$answer);


    $isOkay = $this->is($id) && $question_meta->is($question_id) ;

    if ($isOkay) {

      $answer_id =  $broker->update($id,$values);
      $question = new Question($question_id);
      $isRank = $question->type_ == "rank";
      $isCheckbox = $question->type_ == "checkbox";

      if ($isRank) {
        $this->updateRank($answer_id,$user_id,$question_id,$answer);
      } else if ($isCheckbox){      
        $this->updateCheckbox($answer_id,$user_id,$question_id,$answer);
      }
    } else {
      $answer_id = false;
    }      
    
    return $answer_id;

  }

  function delete($id) {
    $broker = $this->broker_;
    $ans = $broker->delete($id);
    return $ans;
  }

  

  //```````````````````````
  // PRIVATE
  //```````````````````````

  function getSql($value,$type = "text") {
    $sql = $this->broker_->getSql($value,$type);
    return $sql;
  }   

  function getSqlId($value) {
    return $this->getSql($value,$this->names_["id"]);
  }    

  function getSqlQuestionId($value) {
    return $this->getSql($value,$this->names_["question_id"]);
  }  

  function getSqlUserId($value) {
    return $this->getSql($value,$this->names_["user_id"]);
  }  

  function getSqlDate($value) {
    $db = new DbMeta();
    return $db->getSqlDate($value,$this->names_["datee"]);
  }  

  function getSqlTime($value) {
    $db = new DbMeta();
    return $db->getSqlTime($value,$this->names_["time"]);
  }  

  function getSqlAnswer($value) {
    return $this->getSql($value,$this->names_["answer"]);
  }  


  function updateCheckbox($answer_id,$user_id,$question_id,$answer) {
    $multi = new MultipleChoiceAnswerMeta();
    $multi->deleteAnswer($answer_id);
    $id = $this->saveCheckbox($answer_id,$user_id,$question_id,$answer);
    return $id;
  }    

  function updateRank($answer_id,$user_id,$question_id,$answer) {
    $multi = new MultipleChoiceAnswerMeta();
    $multi->deleteAnswer($answer_id);
    $id = $this->saveRank($answer_id,$user_id,$question_id,$answer);
    return $id;
  }    


  function saveCheckbox($answer_id,$user_id,$question_id,$answer) {

    $id = false;

    if ($this->is($answer_id)) {

      global $root;
      $root->openDB();

      $format = new Format();
      $answers = $format->delimit($answer,",");

      foreach ($answers as $letter) {
        if ($letter != "") {
          $value = "X";

          $multiplechoiceanswer = new MultipleChoiceAnswerMeta();
          $id = $multiplechoiceanswer->save($answer_id,$user_id,$question_id,$letter,$value);
        }          
      }        
      
    }      
    return $id;
  }    

  function saveRank($answer_id,$user_id,$question_id,$answer) {
    $id = false;
    if ($this->is($answer_id)) {

      global $root;
      $root->openDB();

      $format = new Format();
      $answers = $format->delimit($answer,";");

      foreach ($answers as $ans) {
        if ($ans != "") {
          $ans = $format->delimit($ans,"-");
          $letter = $ans[0];
          $value = $ans[1];
          $multiplechoiceanswer = new MultipleChoiceAnswerMeta();
          $id = $multiplechoiceanswer->save($answer_id,$user_id,$question_id,$letter,$value);
        } else {
          
        }          
      }        
    }      
    return $id;
  }  



  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("answer-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("answer-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("answer-meta.php",$msg);  
  } 
  
}  



?>
