
<?

global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");
require_once( $root->pathTo() . "_php/multiple-choice-meta.php");
require_once( $root->pathTo() . "_php/multiple-choice.php");


class MultipleChoiceAgent {

  var $ids_;

  var $meta_;  
  var $peek_;

  function MultipleChoiceAgent() {
    $this->meta_ = new MultipleChoiceMeta();
    $this->ids_ = array();
    $this->peek_ = "";
  }  

  function load($question_id) {
    $sqlQuestionId = $this->meta_->getSqlQuestionId($question_id);
    $query = "select * from multiplechoices where lower(question_id) = $sqlQuestionId";
    $this->search($query);
  }    

  function loadChoices($question_id) {

    $this->load($question_id);
    $i=-1;

    $multiple_choices = array();
    while ($this->peek() != false) {
      $i++;
      $choice = new MultipleChoice();
      $tmpid = $choice->load($this->pop());
      $multiple_choices[$i] = $choice;
    }
    return $multiple_choices;
  }    

  function saveChoices($question_id,$multiple_choices) {
    if ($multiple_choices != "") {
      foreach($multiple_choices as $item) {
        $letter = $item->letter_;
        $choice = $item->choice_;
        $this->meta_->save($question_id,$letter,$choice);      
      }
    }
  }    

  function updateChoices($question_id,$multiple_choices) {
    if ($multiple_choices != "") {
      foreach($multiple_choices as $item) {
        $letter = $item->letter_;
        $choice = $item->choice_;

        $isNew = (empty($item->id_));
        $isValid = (!$isNew && $this->meta_->is($item->id_));

        if ($isNew || !$isValid) {
          $this->meta_->save($question_id,$letter,$choice);
        } else {
          $this->meta_->update($item->id_,$question_id,$letter,$choice);
        }
      }
    }
  }    


  function search($query) {
    global $root;
    $root->openDB();
    
    $result = mysql_query($query);
    $this->alertSql("search($query):failed");
    while ($row = mysql_fetch_array($result)) {
      $this->push($row["id"]);
    }
    $this->normalize();
  }  

  function push($id) { 
    array_push($this->ids_,$id);  
  }    

  function pop() {
    $value = ($this->peek_ == "") ? $this->next() : $this->peek_;
    $this->peek_ = "";
    return $value;
  }

  function peek() {
    if ($this->peek_ == "") {
      $this->peek_ = $this->pop();
    }
    $ans = $this->peek_;
    return ($ans == false) ? $ans : $ans["value"];
  }    

  function next() {
    $ans = each($this->ids_);
    return ($ans == false) ? $ans : $ans["value"];
  }    

  function normalize() {
    $this->ids_ = array_unique($this->ids_);
    sort($this->ids_);
  }  

  function numResults() {
    if (!isset($this->ids_)) {
      $num = 0;
    } else {      
      $num = count($this->ids_);
    }
    return $num;
  }    

  function isEmpty() {
    return ($this->numResults() == 0);
  }    


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("multiple-choice-agent.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("multiple-choice-agent.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("multiple-choice-agent.php",$msg);  
  } 

  
}  



?>