
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");

class MultipleChoiceAnswerMeta{

  var $id_;
  var $user_id_;
  var $answer_id_;
  var $question_id_;
  var $letter_;
  var $answer_;

  var $table_;
  var $pid_;
  var $names_;
  var $broker_;

  function MultipleChoiceAnswerMeta() {
    $this->table_ = "multiplechoiceanswers";
    $this->pid_ = "id";
    $this->names_[$this->pid_] = "int";    
    $this->names_["answer_id"] = "int";
    $this->names_["user_id"] = "int";
    $this->names_["question_id"] = "int";    
    $this->names_["letter"] = "text";
    $this->names_["answer"] = "text";
    $this->broker_ = new Broker($this->table_,$this->pid_,$this->names_);
  }

  function set($id,$answer_id,$user_id,$question_id,$letter,$answer) {

    $this->id_ = $id;
    $this->answer_id_ = $answer_id;
    $this->user_id_ = $user_id;    
    $this->question_id_ = $question_id;
    $this->letter_ = $letter;
    $this->answer_ = $answer;
  }  


  function get($answer_id,$user_id,$question_id,$letter,$answer) {
    
    $values["answer_id"] = $answer_id;
    $values["user_id"] = $user_id;
    $values["question_id"] = $question_id;
    $values["letter"] = $letter;
    $values["answer"] = $answer;
    return $values;
  } 



  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($id) {
    $is = $this->broker_->is($id);
    return $is;
  } 


  //```````````````````````
  // BROKER
  //```````````````````````

  function load($id) {
    $this->broker_->load($id);
    $ans = $this->broker_->get();
    if (!empty($ans)) {    
      $this->set($id,$ans["answer_id"],$ans["user_id"],$ans["question_id"],$ans["letter"],$ans["answer"]);
    }
    $id = (!empty($ans)) ? $ans["id"] : false;
    return $id;
  }  

  function save($answer_id,$user_id,$question_id,$letter,$answer) {

    $answer_meta = new AnswerMeta();
    $user_meta = new UserMeta();
    
    $isAnswer = $answer_meta->is($answer_id);
    $isUser = $user_meta->is($user_id);

    $broker = $this->broker_;
    $values = $this->get($answer_id,$user_id,$question_id,$letter,$answer);
    $answer_id = $isAnswer && $isUser  ? $broker->save($values) : false;
    return $answer_id;

  }

  function delete($id) {
    $broker = $this->broker_;
    $ans = $broker->delete($answer_id);
    return $ans;

  }


  function deleteAnswer($answer_id) {

    $answer_meta = new AnswerMeta();
    $isAnswer = $answer_meta->is($answer_id);

    if ($isAnswer) {

      global $root;
      $root->openDB();

      $sqlAnswerId = $this->getSqlAnswerId($answer_id);
      $query = "delete from multiplechoiceanswers where lower(answer_id) = $sqlAnswerId";
      $result = mysql_query($query);
      $ans = (mysql_affected_rows() > 0);
    }
    return ($isAnswer) ? $ans : false;

  }
  

  //```````````````````````
  // PRIVATE
  //```````````````````````

  function getSql($value,$type = "text") {
    $sql = $this->broker_->getSql($value,$type);
    return $sql;
  }    

  function getSqlId($value) {
    return $this->getSql($value,$this->names_["id"]);
  }    

  function getSqlAnswerId($value) {
    return $this->getSql($value,$this->names_["answer_id"]);
  } 

  function getSqlUserId($value) {
    return $this->getSql($value,$this->names_["user_id"]);
  }  

  function getSqlQuestionId($value) {
    return $this->getSql($value,$this->names_["question_id"]);
  } 

  function getSqlLetter($value) {
    return $this->getSql($value,$this->names_["letter"]);
  }  

  function getSqlAnswer($value) {
    return $this->getSql($value,$this->names_["answer"]);
  }  


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("multiple-choice-answer-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("multiple-choice-answer-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("multiple-choice-answer-meta.php",$msg);  
  } 
  
}  



?>
