
<?

$root = new Root();

$db[$root->production_]["name"] = "andrewfwd";
//$db[$root->production_]["name"] = "docsurvey";
$db[$root->dev1_]["name"] = "docsurvey_dev";
$db[$root->home_]["name"] = "docsurvey";

//$db[$root->production_]["userid"] = "aforward";
$db[$root->production_]["userid"] = "andrewfwd";
$db[$root->dev1_]["userid"] = "aforward";
$db[$root->home_]["userid"] = "root";


//$db[$root->production_]["pwd"] = "hello";
$db[$root->production_]["pwd"] = "tmp2563";
$db[$root->dev1_]["pwd"] = "hello";
$db[$root->home_]["pwd"] = "";

$db[$root->production_]["server"] = "db1";
//$db[$root->production_]["server"] = "localhost";
$db[$root->dev1_]["server"] = "localhost";
$db[$root->home_]["server"] = "localhost";

$home[$root->production_]["dir"] = "docsurvey";
$home[$root->dev1_]["dir"] = "docsurvey_dev";
$home[$root->home_]["dir"] = "docsurvey";

$home[$root->production_]["tools"] = "_php/";
$home[$root->dev1_]["tools"] = "_php/";
$home[$root->home_]["tools"] = "../tools/";


$root->setEnv($home,$db);


//~~~~~~~~~~~~~~~~~~~~~
// LOAD MODULES

require_once($root->pathToTools() . "debug.php");
require_once($root->pathToTools() . "db.php");
require_once($root->pathToTools() . "format.php");
require_once($root->pathToTools() . "forms.php");
require_once($root->pathToTools() . "broker.php");

require_once($root->pathToPHP() . "user.php");
require_once($root->pathToPHP() . "user-agent.php");
require_once($root->pathToPHP() . "user-meta.php");

require_once($root->pathToPHP() ."question.php");
require_once($root->pathToPHP() ."question-agent.php");
require_once($root->pathToPHP() ."question-meta.php");

require_once($root->pathToPHP() . "multiple-choice.php");
require_once($root->pathToPHP() . "multiple-choice-meta.php");
require_once($root->pathToPHP() . "multiple-choice-agent.php");

require_once($root->pathToPHP() . "opinion-agent.php");

require_once($root->pathToPHP() ."answer.php");
require_once($root->pathToPHP() ."answer-meta.php");
require_once($root->pathToPHP() ."answer-agent.php");

require_once($root->pathToPHP() . "multiple-choice-answer-meta.php");

require_once($root->pathToPHP() . "result-agent.php");


class Root {

  var $db_;
  var $box_;
  var $path_;

  var $production_ = "production";
  var $dev1_ = "development";
  var $home_ = "home";

  function Root() {
    global $HTTP_SERVER_VARS;
    $this->path_ = isset($HTTP_SERVER_VARS["REQUEST_URI"]) ? $HTTP_SERVER_VARS["REQUEST_URI"] : $HTTP_SERVER_VARS["PATH_INFO"];
  }

  //```````````````````````
  //  SET-UP
  //```````````````````````

  function setUser($userid,$pwd,$server="24.42.138.221") {
    $this->db_["userid"] = $userid;
    $this->db_["pwd"] = $pwd;
    $this->db_["server"] = $server;
  }    

  function setEnv($home,$db) {

    global $database,$HTTP_SERVER_VARS;

    if (isset($HTTP_SERVER_VARS["REQUEST_URI"])) {
      $box = stristr($this->path_,$home[$this->dev1_]["dir"]) ? $this->dev1_ : $this->production_;
    } else {
      $box = $this->home_;
    }

    $database = (empty($database)) ? "" : $database;

    $this->box_["name"] = $box;
    $this->box_["tools"] = $home[$box]["tools"];
    $this->box_["dir"] = $home[$box]["dir"];
    $this->box_["root"] =  $home[$box]["dir"] . "/";

    $this->setUser($db[$box]["userid"],$db[$box]["pwd"],$db[$box]["server"]);
    $this->db_["name"] = ($database == "prod") ? $db[$this->production_]["name"] : $db[$box]["name"];
    
  }    

  function setDb() {
    if (empty($this->db_["connection"])) {
      $this->db_["connection"] = new DB($this->db_["name"],$this->db_["userid"],$this->db_["pwd"],$this->db_["server"]);
    }
  }    

  //```````````````````````
  //  DATABASE OPERATIONS
  //```````````````````````

  function openDb() {
    $this->setDb();
    $this->db_["connection"]->open();
  }    

  function closeDB() {
    $this->setDb();
    $this->db_["connection"]->close();
  }  


  //```````````````````````
  // PATH CALCULATIONS
  //```````````````````````

  function pathTo() {

    $rootDir = $this->box_["root"];
    $path = $this->path_;

    $real_path = substr($path,1,strlen($path) - strlen($this->page()) - 1);
    $path_from_root = str_replace($real_path,"",$rootDir);

    $dirs_from_root = 0;
    for ($i=0; $i < strlen($path_from_root); $i++) {
      if (strcmp($path_from_root[$i],"/") == 0 ) {
        $dirs_from_root +=1;
      }
    }

    return $this->makePathTo($dirs_from_root);
    
  }

  function pathToTools() {
    return $this->pathTo() . $this->box_["tools"];
  }    

  function pathToTestSuite() {
    return $this->pathTo() . "_testsuite/";
  }    

  function pathToPHP() {
    $path = $this->pathTo() . "_php/";
    return $path;
  }    


  function pathFrom() {

    $rootDir = $this->box_["root"];
    $path = $this->path_;
    
    $path_from_root = substr($path,strlen($rootDir) );
    $page = $this->page();
    $path_from_root = str_replace($page,"",$path_from_root);

    return $path_from_root;

  }    

  function makePathTo($n) {

   $ans = "";
   for ($i=1; $i <= $n; $i++) {
     $ans = $ans . "../";
   }
   return $ans;

  }

  function page() {
    
    $path = $this->path_;
    $page = "";
    for ($i = strlen($path) - 1; $i >= 1 && (strcmp($path[$i],"/") != 0); $i--) {
      $page = $path[$i] . $page;
    }
    return $page;
  }




  //```````````````````````
  // STYLE
  //```````````````````````

  function css($id="default") {

    if (strcmp($id,"default")==0) {
      ?><link rel="STYLESHEET" type="text/css" href="<?=$this->pathTo()?>_scripts/css/text.css"><?
    } else if (strcmp($id,"common")==0) {
      ?><LINK REL=Stylesheet type="text/css" href="<?=$this->pathTo()?>_scripts/css/common.css"><?
    }    
  }


  function jscripts() {
    ?><script language=JavaScript src="<?=$this->pathTo()?>_scripts/js/validator.js"></script><?
    ?><script language=JavaScript src="<?=$this->pathTo()?>_scripts/js/forms.js"></script><?
    ?><script language=JavaScript src="<?=$this->pathTo();?>_scripts/js/calendar.js"></script><?
    ?><script language=JavaScript src="<?=$this->pathTo();?>_scripts/js/div_construct.js"></script><?
    ?><script language=JavaScript src="<?=$this->pathTo();?>_scripts/js/survey.js"></script><?
  }  


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    print("<br><font color=red>root.php $msg</font><br>");
  }    

  function debug_r($msg) {
    print ("<br><font color=red>");
    print("root.php");
    print_r ($msg);
    print ("</font><br>");
  }    

  function alertSql($msg) {
    if (mysql_errno()) {
      alert("root.php $msg", mysql_errno() . ": " . mysql_error());
    }   
  } 


}  







?>


