
<?
global $root;
require_once( $root->pathTo() . $root->box_["tools"]  . "db.php");


class UserMeta {

  var $id_;
  var $email_;  
  var $pwd_;


  var $table_;
  var $pid_;
  var $names_;
  var $broker_;
  

  var $defaultEmail_ = "default";
  var $defaultPwd_ = ""; 

  function UserMeta() {
    $this->table_ = "users";
    $this->pid_ = "id";
    $this->names_[$this->pid_] = "int";    
    $this->names_["email"] = "text";
    $this->names_["pwd"] = "text";
    $this->broker_ = new Broker($this->table_,$this->pid_,$this->names_);
  }  

  function set($id,$email,$pwd) {
    $this->id_ = $id;
    $this->email_ = $email;
    $this->pwd_ = $pwd;
  }  

  function get($email,$pwd) {
    $values["email"] = $email;
    $values["pwd"] = $pwd;
    return $values;
  }    

  //```````````````````````
  // INTERFACE
  //```````````````````````

  function is($id) {
    $is = $this->broker_->is($id);
    return $is;
  } 

  function isLogin($email,$pwd) {

    global $root;
    $root->openDB();

    $sqlEmail = $this->getSqlEmail($email);
    $query = "select pwd from users where lower(email) = $sqlEmail";
    $result = mysql_query($query);
    $this->alertSql("isLogin($email,$pwd): query failed");
    $ans = mysql_fetch_array($result);
    $this->alertSql("isLogin($email,$pwd): fetch array failed");
    return ((strcmp($pwd,$ans["pwd"])==0 or ($ans["pwd"] == null) or $ans["pwd"] == "") and ($this->isEmail($email)));
    
  }    

  function isEmail($email) {

    global $root;
    $root->openDB();
    
    $sqlEmail = $this->getSqlEmail($email);
    
    $query = "select email from users where lower(email) = $sqlEmail";
    $result = mysql_query($query);
    $this->alertSql("isEmail(): query failed");
    $ans = (mysql_num_rows($result) == 1);
    return $ans;  
  }    

  function isConsent($id) {

    global $root;
    $root->openDB();

    $sqlId = $this->getSqlId($id);
    $query = "select consent from users where lower(id) = $sqlId";
    $result = mysql_query($query);
    $this->alertSql("isConsent(): query failed");
    $ans = mysql_fetch_array($result);
    return $ans["consent"] == "Yes";
  }    

  function consented($id) {

    if ($this->is($id)) {

      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);
      $query = "update users set consent='Yes' where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("isConsent(): query failed");
      $ans = (mysql_affected_rows() > 0);
    } else {
      $ans = false;
    }
    return $ans;   
  }    

  function answered($id,$question_id) {

    if ($this->is($id)) {

      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);
      $sqlQuestionId = $this->getSqlQuestionId($question_id);
      
      $query = "update users set question_id=$sqlQuestionId where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("answered(): query failed");
      $ans = (mysql_affected_rows() > 0);
    } else {
      $ans = false;
    }
    return $ans;   
  } 

  function nextQuestion($id) {
    if ($this->is($id)) {

      global $root;
      $root->openDB();

      $sqlId = $this->getSqlId($id);

      $query = "select question_id from users where lower(id) = $sqlId";
      $result = mysql_query($query);
      $this->alertSql("nextQuestion(): query failed");
      $ans = mysql_fetch_array($result);
      $next = (integer)$ans["question_id"] + 1;
    } else {
      $next = 1;
    }
    return $next;   

  }    


  //```````````````````````
  // BROKER
  //```````````````````````

  function defaultt() {
    $email = $this->defaultEmail_;
    $pwd = $this->defaultPwd_;
    $id = $this->save($email,$pwd);   
    return $id;
  }    
 
  function load($id) {
    $this->broker_->load($id);
    $ans = $this->broker_->get();
    if (!empty($ans)) {    
      $this->set($ans["id"],$ans["email"],$ans["pwd"]);
      $id = $ans["id"];
    } else {
      $id = false;
    }      
    return $id;
  } 

  function save($email,$pwd) {
    $isDefault = ($email == $this->defaultEmail_) && ($pwd == $this->defaultPwd_);
    $isNewEmail = !$this->isEmail($email);
    $broker = $this->broker_;
    $values = $this->get($email,$pwd);
    $ans = ($isNewEmail || $isDefault) ? $broker->save($values) : false;
    return $ans;
  }

  function update($id,$email,$pwd) {
    $isOkay = $this->is($id);
    $broker = $this->broker_;
    $values = $this->get($email,$pwd);
    $ans = $isOkay ? $broker->update($id,$values) : false;
    return $ans;
  }    

  function delete($id) {
    $broker = $this->broker_;
    $ans = $broker->delete($id);
    return $ans;
  }

  function loadByEmail($email) {
    $broker = $this->broker_;
    $id = $broker->loadBy("email",$email);
    return $id;
  } 


  //```````````````````````
  // PRIVATE
  //```````````````````````

  function getSql($value) {
    $db = new DbMeta();
    return $db->getSqlQuotes($value);
  }    

  function getSqlId($value) {
    return $this->getSql($value);
  }  

  function getSqlEmail($value) {
    return $this->getSql($value);
  }  

  function getSqlPwd($value) {
    return $this->getSql($value);
  }  

  function getSqlQuestionId($value) {
    return $this->getSql($value);
  } 

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("user-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("user-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("user-meta.php",$msg);  
  } 

  
}  



?>
