

function getRankId(input) {
  var name = input.name;
  var lowerIndex = name.indexOf(':') + 1;
  var id = name.substring(lowerIndex);
  return id;
}  

function validateRank(input) {

  var value = input.value;
  var min = 1;
  var max = 5;

  var isFormatOkay = isInteger(value);

  var isNA = (value == "na");  
  var isBefore = isFormatOkay && (value < min);
  var isAfter = isFormatOkay && (value > max);
  var isValid = (!isBefore && !isAfter && isFormatOkay) || isNA;

  if (!isValid) {
    alert("Please provide a rank between " + min + " and " + max);
  }    

  return isValid;

}  


function updateRank(ans,input) {

  var isOkay = validateRank(input);

  if (!isOkay) {
    input.value = '';
    input.focus();
  }    

  var value = input.value;
  var old_ans = ans.value;
  var isEmpty = (old_ans.length == 0);
  var id = getRankId(input);
  ans.value = replaceValue(old_ans,id,value);
  //ans.value = 'hi';
  
}  


function updateChoices(ans,checkbox) {

  var item = checkbox.value;
  var old_ans = ans.value;
  var isEmpty = (old_ans.length == 0);
  var addAnswer = checkbox.checked;
  

  if (isEmpty && addAnswer) {
    ans.value = item;
  } else if (!isEmpty && addAnswer) {
    ans.value += ',' + item;
  } else if (!addAnswer) {
    ans.value = removeValue(old_ans,item);
  } 

}


function replaceValue(str,id,value) {

  var iStart = str.indexOf(id);
  var isValid = (iStart != -1);

  var iEnd = -1;
  if (isValid) {
    var index = str.indexOf(';',iStart)
    iEnd = (index != -1) ? index : str.length;
  }
    
  var isNew = (str.length == 0);
  var isEmpty = (value.length == 0)
  var isReplaced = !isEmpty & !isNew;

  var entry = (isEmpty) ? '' : id + '-' + value;  
  entry = (!isNew && !isEmpty) ? ';' + entry : entry;
  var ans = remove(str,iStart,iEnd) + entry;
  return ans; 

}  

function remove(str,iStart,iEnd) {

  var isValid = (iStart != -1);

  var lowerIndex = 0;
  var midIndex = iStart-1;
  var upperIndex = iEnd;
  var endIndex = str.length;

  var isAtStart = (iStart == lowerIndex && isValid);
  var isInMiddle = (upperIndex != endIndex && isValid);
  var isAtEnd = (upperIndex == endIndex && isValid);
  var isOnlyLetter = (item.length == str.length && isValid)

  var ans = '';  

  if (isAtStart) {
    ans = str.substring(upperIndex + 1);
  } else if (isInMiddle) {
    ans = str.substring(lowerIndex,midIndex) + str.substring(upperIndex);
  } else if (isAtEnd) {
    ans = str.substring(lowerIndex,midIndex);
  } else {
    ans = str;
  }    

  return ans;

}  

function removeValue(str,item) {

  var iStart = str.indexOf(item);
  var iEnd = iStart + item.length;
  return remove(str,iStart,iEnd);
}  


