
// `````````````
//  COMMON FUNCTIONALITY
// ``````````````

function doRedirect(href,timeout) {
    setTimeout( "window.location.href = " + href, timeout );
}


function isEmpty(value) {
  var empty = (value.length == 0);
	return (empty);  
}	

function hasSpaces(value) {
  var spaces = (value.indexOf(' ') >= 0);
	return (spaces);
}	


function popupErrorsOnPage(arrMsg) {

  var error = "Errors On Page\n\n";
	
  for (var i=0; i < arrMsg.length; i++) {
    error = error + arrMsg[i] + "\n";
	}  

  alert(error);  
}

// `````````````
//  CONFIRMATION SELECTOR
// ``````````````

function confirm(type,fm) {

  var ans;

  if (type == 'answer') {
    ans = confirmAnswer(fm);
	} else if (type == 'login') {
	  ans = confirmLogin(fm);
	} else {		
	  alert("Confirmation Unknown");
    ans = false;
	}
  return ans;
}	


function confirmLogin(fm) {
  var email = fm.email.value;

  var arrErrors = new Array();
	
  var i=0;
  if (! isEmailValid(email)) {
    arrErrors[i++] = getEmailError(email);
	}	

  var isOkay = (arrErrors.length == 0);

	if (! isOkay) {
		alert(getEmailError(email));
	}
  return isOkay;
	
}	

function confirmAnswer(fm) {

	var ans = fm.answer.value;
	
  var arrErrors = new Array();
	
  var i=0;
  if (! isAnswerValid(ans)) {
    arrErrors[i++] = getAnswerError(ans);
	}	 

  var isOkay = (arrErrors.length == 0);

	if (! isOkay) {
    popupErrorsOnPage(arrErrors);
	}	
  return isOkay;
	
}	





// `````````````
//  CHECKING THE VALUES
// ``````````````



function isEmailValid(email) {

  var at = email.indexOf('@')
	var dot = email.indexOf(".");

  var noSpaces = (email.indexOf(' ')== -1);
	var hasAt = (at > 0);
	var hasDot = (dot > 0);
	var hasDotAfterAt = (dot > at);
	var hasSomethingAfterDot = (dot + 1 < email.length);
	var isEmpty = (email.length == 0);
	return (noSpaces && hasAt && hasDot && hasDotAfterAt && hasSomethingAfterDot || isEmpty);

}	


function isAnswerValid(value) {
	return (!isEmpty(value));
}	



// `````````````
//  GENERIC VALIDATIONS
// ``````````````

function isInteger(val) {
  var isOkay = true;
	for (var i=0; i < val.length && isOkay; i++) {
		if (!isDigit(val.charAt(i))) {
      isOkay = false;
    }
	}
	return isOkay;
}

function isDigit(num) {
	var string="1234567890";
  var ans = (string.indexOf(num) != -1) ;
	return ans;
}




// `````````````
//  RETURNING THE ERROR
// ``````````````

function getEmptyError(value,name) {

	var empty = (value.length == 0);

  var $err;

  if (empty) {
    $err = "Please provide a " + name;
	} else {
    $err = "Your " + name + " seems okay";
	}

  return $err;
}

function getAnswerError(value) {
  return getEmptyError(value,"answer");
}

function getEmailError(email) {

  var at = email.indexOf('@')
	var dot = email.indexOf(".");

  var spaces = (email.indexOf(' ') != -1);
  var empty = (email.length == 0);
	var noAt = (at == -1);
	var noDot = (dot == -1);
	var noDotAfterAt = (dot < at);
	var nothingAfterDot = (dot + 1 >= email.length);

  var $err;

  if (spaces) {
    $err = "Please remove the spaces in you email address.";
	//} else if (empty) {
  //  $err = "...Please provide your email address";
	} else if (noAt || noDot || noDotAfterAt || nothingAfterDot) {
    $err = "Please provide a valid email address.";
	} else {
    $err = "Your email seems okay";
	}		

  return $err;
	

}	





