
<?

require_once("../_php/root.php");

global $root;
require_once($root->pathToTools() . "testcase.php");
require_once($root->pathToPHP() . "answer-meta.php");

if ($root->page() == "test_answer-meta.php") {
  $test = new AnswerMetaTest();
  $test->runAll();
}    

class AnswerMetaTest {

  var $passed_;
  var $failed_;
  var $title_;

  var $tests_;

  function AnswerMetaTest($title = "AnswerMetaTest") {

    $testcase = new TestCase();

    $this->passed_ = $testcase->passed();
    $this->failed_ = $testcase->failed();
    $this->tests_ = Array();
    $this->title_ = $title;
  }    

  function doAll() {
    $i=-1;
    $this->tests_[$i++] = $this->test_set();
    $this->tests_[$i++] = $this->test_is();
    $this->tests_[$i++] = $this->test_load();
     $this->tests_[$i++] = $this->test_save();
     $this->tests_[$i++] = $this->test_update();
     $this->tests_[$i++] = $this->test_delete();
    return $this->tests_;
  }    

  function runAll() {
    $this->doAll();
    $testcase = new TestCase($this->title_);
    $testcase->intro($this->title_);
    foreach ($this->tests_ as $testIndex) {
      $testIndex->show();
    }      
  }   


  function setUp($id = 1) {

    if ($id == 2) {
      $data["id"] = "123";
      $data["question_id"] = "2";
      $data["user_id"] = "1";
      $data["date"] = "";
      $data["time"] = "10:15:10";
      $data["answer"] = "3";
    } else {
      $data["id"] = "124";
      $data["question_id"] = "3";
      $data["user_id"] = "2";
      $data["date"] = "2002-11-01";
      $data["time"] = "";
      $data["answer"] = "my three";
    }      

    return $data;
    
  }    

  function test_set() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $data = $this->setUp();

    $b = new AnswerMeta();
    $b->set($data["id"],$data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);

    $testcase = new Testcase("AnswerMeta.set()");

    $descr = "set(), checking id";
    $isSame = ($data["id"] == $b->id_);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking question";
    $isSame = ($data["question_id"] == $b->question_id_);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking user";
    $isSame = ($data["user_id"] == $b->user_id_);
    $ans = $b->user_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking date";
    $isSame = ($data["date"] == $b->date_);
    $ans = $b->date_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking time";
    $isSame = ($data["time"] == $b->time_);
    $ans = $b->time_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "set(), checking answer";
    $isSame = ($data["answer"] == $b->answer_);
    $ans = $b->answer_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }

  function test_is() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $data = $this->setUp();
   
    $testcase = new Testcase("AnswerMeta.is()");

    $descr = "Check for a null Answer";
    $a = new AnswerMeta();
    $id = "";
    $ans = $a->is($id);
    $result = ($id == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Check for a 0 Answer";
    $a = new AnswerMeta();
    $id = 0;
    $ans = $a->is($id);
    $result = ($id == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $a = new AnswerMeta();
    $id = $a->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $descr = "Cheking  newly created Answer exists";
    $ans = $id;
    $result = ($a->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);   

    
    $descr = "Checking deleted Answer does not exist";
    $ans = $a->delete($id);
    $result = ($a->is($id) == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }    

  function test_load() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new AnswerMeta();

    $data = $this->setUp();
        
    $testcase = new Testcase("AnswerMeta.load(id)");

    $a = new AnswerMeta();
    $id = -1;
    $isLoadOkay = $a->load($id);

    $descr = "Loading Bad Answer";
    $ans = $isLoadOkay;
    $result = (!$meta->is($id) && $isLoadOkay == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Creating new Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $a = new AnswerMeta();
    $id = $a->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Loading Answer ($id)";
    $b = new AnswerMeta();
    $id = $b->load($id);
    $ans = $id;
    $result = ($meta->is($id) && $id != false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking id";
    $isSame = ($id == $b->id_);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "question_id";
    $descr = "Answer ($id), checking $name";
    $isSame = ($data[$name] == $b->question_id_);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "user_id";
    $descr = "Answer ($id), checking $name";
    $isSame = ($data[$name] == $b->user_id_);
    $ans = $b->user_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "date";
    $descr = "Answer ($id), checking $name";
    $isSame = ($data[$name] == $b->date_);
    $ans = $b->date_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $name = "time";
    $db = new DBMeta();
    $time1 = substr($db->getTime(),0,5);
    $time2 = substr($b->time_,0,5);
   
    $descr = "Answer ($id), checking $name";
    $isSame = ($time1== $time2);
    $ans = $b->time_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $name = "answer";
    $descr = "Answer ($id), checking $name";
    $isSame = ($data[$name] == $b->answer_);
    $ans = $b->answer_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $data = $this->setUp(2);

    $descr = "Creating new Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $b = new AnswerMeta();
    $id2 = $a->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $b->load($id2);
    $ans = $id2;
    $result = ($meta->is($id2)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id2), checking id";
    $isSame = ($id2 == $b->id_);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id2), checking question";
    $isSame = ($data["question_id"] == $b->question_id_);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id2), checking user";
    $isSame = ($data["user_id"] == $b->user_id_);
    $ans = $b->user_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $db = new DBMeta();
    $descr = "Answer ($id2), checking date";
    $isSame = ($db->getToday() == $b->date_);
    $ans = $b->date_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $db = new DBMeta();
    $time1 = "10:15:10";
    $time2 = $b->time_;

    $descr = "Answer ($id), checking time";
    $isSame = ($time1 == $time2);
    $ans = $b->time_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking answer";
    $isSame = ($data["answer"] == $b->answer_);
    $ans = $b->answer_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Removing Answers";  
    $meta->delete($id);
    $meta->delete($id2);
    $ans = (! $meta->is($id) && ! $meta->is($id2)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);
   
    return $testcase;
    

  }  


  function test_save() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new AnswerMeta();

    $data = $this->setUp();


    $a = new AnswerMeta();

    $testcase = new Testcase("AnswerMeta.save()");

    $descr = "Creating new Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $id = $a->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    
    $descr= "Saving that Answer again";  
    $id2 = $a->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $ans = $id2;
    $result = ($meta->is($id2) && $id != $id2) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Removing Answers";  
    $meta->delete($id);
    $meta->delete($id2);
    $ans = (! $meta->is($id) && ! $meta->is($id2)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }  


  function test_update() {

    

    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new AnswerMeta();

    $testcase = new Testcase("AnswerMeta.update()");


    $data = $this->setUp();

    $descr = "Creating new Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $b = new AnswerMeta();
    $id = $b->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $b->load($id);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking id";
    $isSame = ($id == $b->id_);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking question";
    $isSame = ($data["question_id"] == $b->question_id_);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking user";
    $isSame = ($data["user_id"] == $b->user_id_);
    $ans = $b->user_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking date";
    $isSame = ($data["date"] == $b->date_);
    $ans = $b->date_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $db = new DBMeta();
    $time1 = substr($db->getTime(),0,5);
    $time2 = substr($b->time_,0,5);

    $descr = "Answer ($id), checking time";
    $isSame = ($time1 == $time2);
    $ans = $b->time_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Answer ($id), checking answer";
    $isSame = ($data["answer"] == $b->answer_);
    $ans = $b->answer_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $data = $this->setUp(2);


    $descr = "Updating Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $b->update($id,$data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $b = new AnswerMeta();
    $id2 = $b->load($id);
    $ans = $id2;
    $result = ($meta->is($id2) && $id2 == $id) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking id";
    $isSame = ($id == $b->id_);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking question";
    $isSame = ($data["question_id"] == $b->question_id_);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking user";
    $isSame = ($data["user_id"] == $b->user_id_);
    $ans = $b->user_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking date";

    $db = new DBMeta();
    $date1 = $db->getToday();
    $date2 = $b->date_;
   
    $isSame = ($date1 == $date2);
    $ans = $b->date_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Answer ($id), checking time";
    $isSame = ($data["time"] == $b->time_);
    $ans = $b->time_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Answer ($id), checking answer";
    $isSame = ($data["answer"] == $b->answer_);
    $ans = $b->answer_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Removing Answers";  
    $meta->delete($id);
    $meta->delete($id2);
    $ans = (! $meta->is($id) && ! $meta->is($id2)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }  


  function test_delete() {


    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new AnswerMeta();


    $testcase = new Testcase("AnswerMeta.delete()");

    $data = $this->setUp();

    $descr = "Creating new Answer (" . $data["question_id"] . ", " . $data["user_id"] . "," . $data["date"] ."," . $data["time"] .",". $data["answer"] . ")";
    $b = new AnswerMeta();
    $id = $b->save($data["question_id"],$data["user_id"],$data["date"],$data["time"],$data["answer"]);
    $b->load($id);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Deleting Answer($id)";
    $b = new AnswerMeta();
    $b->delete($id);
    $ans = $id;
    $result = (!$meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;    

  }   

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("test_answer-meta.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("test_answer-meta.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("test_answer-meta.php",$msg);  
  } 



  
}


?>