
<?

require_once("../_php/root.php");

global $root;

require_once($root->pathToTools() . "test.php");
require_once($root->pathToTools() . "testcase.php");

require_once($root->pathToTools() . "broker.php");

if ($root->page() == "test_broker.php") {
  $test = new BrokerTest();
  $test->runAll();
}    

class BrokerTest {

  var $passed_;
  var $failed_;
  var $title_;

  var $tests_;

  var $broker_;

  //`````````````````````
  // THE TEST SUITE
  //`````````````````````  

  function BrokerTest($title = "BrokerTest") {
    global $passed;
    global $failed;

    $this->passed_ = $passed;
    $this->failed_ = $failed;
    $this->tests_ = Array();
    $this->title_ = $title;
  }    

  function doAll() {
    $i=-1;

    $this->setUp();
    $this->tests_[$i++] = $this->test_set();
    $this->tearDown();

    $this->setUp();
    $this->tests_[$i++] = $this->test_is();
    $this->tearDown();

    $this->setUp();
    $this->tests_[$i++] = $this->test_load();
    $this->tearDown();

    $this->setUp();
    $this->tests_[$i++] = $this->test_save();
    $this->tearDown();

    $this->setUp();
    $this->tests_[$i++] = $this->test_update();
    $this->tearDown();

    $this->setUp();
    $this->tests_[$i++] = $this->test_delete();
    $this->tearDown();


    
    return $this->tests_;
  }    

  function runAll() {
    $this->doAll();
    $testcase = new TestCase($this->title_);
    $testcase->intro($this->title_);
    foreach ($this->tests_ as $testIndex) {
      $testIndex->show();
    }      
  }   


  //`````````````````````
  // SET-UP / TEAR DOWN
  //`````````````````````  

  function setUp() {

    global $root;
    $root->openDB();
    
    $query = "CREATE TABLE `tmp` (`id` SMALLINT NOT NULL AUTO_INCREMENT PRIMARY KEY, `text` VARCHAR(10) NOT NULL, `datee` DATE NOT NULL, `time` TIME NOT NULL) ";
    $result = mysql_query($query);
    $this->alertSql("setUp():query failed");

    $table = "tmp";
    $id = "id";
    $names[$id] = "int";
    $names["text"] = "text";
    $names["datee"] = "date";
    $names["time"] = "time";

    $this->broker_ = new Broker($table,$id,$names);

  }    

  function tearDown() {
    global $root;
    $root->openDB();
    
    $query = "DROP TABLE `tmp`";
    $result = mysql_query($query);
    $this->alertSql("tearDown():query failed");
  }    


  //`````````````````````
  // INTERNAL FUNCTIONS
  //`````````````````````  

  function add() {
    $query = "insert into tmp (text,datee,time) values ('howdy','2001-10-15','10:15:10')";
    $result = mysql_query($query);
    $this->alertSql("add():query failed");
    $answer_id = mysql_insert_id();
    return $answer_id;
  }    

  function remove($id = "all") {

    $where = ($id == "all") ? "1" : "id = '$id'";
    $query = "delete from tmp where $where";
    $result = mysql_query($query);
    $this->alertSql("remove():query failed");
  }


  function test_set() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $broker = $this->broker_;

    $id = "1";
    $values["id"] = $id;
    $values["text"] = "howdy";
    $values["datee"] = "2001-10-15";
    $values["time"] = "10:15:11";

    $broker->set($values);

    $testcase = new Testcase("Broker.set()");

    $name = "id";   
    $descr = "set(values), checking $name";
    $isSame = $id == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "text"; 
    $descr = "set(values), checking $name";
    $isSame = $values[$name] == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "datee"; 
    $descr = "set(values), checking $name";
    $isSame = $values[$name] == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "time"; 
    $descr = "set(values), checking $name";
    $isSame = $values[$name] == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }
  


  function test_is() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $broker = $this->broker_;
   

    $testcase = new Testcase("Broker.is()");

    $descr = "Check for a null entry";
    $id = "";
    $ans = $broker->is($id);
    $result = ($id == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Check for a -1 user";
    $id = -1;
    $ans = $broker->is($id);
    $result = (!$ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $id = $this->add();
    $descr = "Cheking  newly created entry exists";
    $ans = $broker->is($id);
    $result = ($id == true) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);   

    $this->remove();
    
    $descr = "Checking deletee entry does not exist";
    $ans = $broker->is($id);
    $result = (!$ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }    

  function test_load() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $broker = $this->broker_;

    $testcase = new Testcase("Broker.load(id)");

    $id = -1;
    $isLoadOkay = $broker->load($id);;
    $descr = "Loading Bad entry";
    $ans = $isLoadOkay;
    $result = (!$broker->is($id) && $isLoadOkay == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $id = $this->add();

    $descr = "Loading User ($id)";
    $isOkay = $broker->load($id);
    $ans = $isOkay;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "id";
    $expected = $id;
    $descr = "Entry($id), checking id";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "text";
    $expected = "howdy";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "datee";
    $expected = "2001-10-15";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "time";
    $expected = "10:15:10";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $this->remove();

    return $testcase;
    

  }  


  function test_save() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $values["text"] = "howdy";
    $values["datee"] = "2001-10-15";
    $values["time"] = "10:15:10";
    
    $broker = $this->broker_;

    $testcase = new Testcase("broker.save()");

    $descr = "Creating entry";
    $id = $broker->save($values);
    $ans = $id;
    $result = ($broker->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    
    $descr= "Creating entry again";  
    $id2 = $broker->save($values);
    $ans = $id2;
    $result = ($broker->is($id2)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $name = "id";
    $expected = $id2;
    $descr = "Entry($id), checking id";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "text";
    $expected = "howdy";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "datee";
    $expected = "2001-10-15";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "time";
    $expected = "10:15:10";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $this->remove();

    return $testcase;

  }  


  function test_update() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $values["text"] = "ydwoh";
    $values["datee"] = "5101-10-02";
    $values["time"] = "15:10:15";
    
    $broker = $this->broker_;

    $testcase = new Testcase("UserMeta.update()");

    $id = $this->add();

    $descr = "Loading User ($id)";
    $isOkay = $broker->load($id);
    $ans = $isOkay;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "id";
    $expected = $id;
    $descr = "Entry($id), checking id";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "text";
    $expected = "howdy";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "datee";
    $expected = "2001-10-15";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "time";
    $expected = "10:15:10";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $broker->update($id,$values);

    $name = "id";
    $expected = $id;
    $descr = "Entry($id), checking id";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "text";
    $expected = "ydwoh";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "datee";
    $expected = "5101-10-02";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $name = "time";
    $expected = "15:10:15";
    $descr = "Entry($id), checking $name";
    $isSame = $expected == $broker->get($name);
    $ans = $broker->get($name);
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $this->remove();

    return $testcase;

  }  


  function test_delete() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $broker = $this->broker_;
    $id = $this->add();

    $testcase = new Testcase("Broker.delete()");

    $descr = "Creating entry";
    $ans = $id;
    $result = ($broker->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Deleting entry";
    $broker->delete($id);
    $ans = $id;
    $result = (!$broker->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;    

  }    

  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("test_broker.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("test_broker.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("test_broker.php",$msg);  
  } 

  
}


?>