
<?

require_once("../_php/root.php");

global $root;
require_once($root->pathToTools() . "testcase.php");
require_once($root->pathToPHP() . "multiple-choice-meta.php");


if ($root->page() == "test_multiple-choice-meta.php") {
  $test = new MultipleChoiceMetaTest();
  $test->runAll();
}    

class MultipleChoiceMetaTest {

  var $passed_;
  var $failed_;
  var $title_;

  var $tests_;

  function MultipleChoiceMetaTest($title = "MultipleChoiceMetaTest") {

    $testcase = new TestCase();

    $this->passed_ = $testcase->passed();
    $this->failed_ = $testcase->failed();
    $this->tests_ = Array();
    $this->title_ = $title;
  }    

  function doAll() {
    $i=-1;
    $this->tests_[$i++] = $this->test_set();
    $this->tests_[$i++] = $this->test_is();
    $this->tests_[$i++] = $this->test_load();
     $this->tests_[$i++] = $this->test_save();
     $this->tests_[$i++] = $this->test_update();
     $this->tests_[$i++] = $this->test_delete();
    return $this->tests_;
  }    

  function runAll() {
    $this->doAll();
    $testcase = new TestCase($this->title_);
    $testcase->intro($this->title_);
    foreach ($this->tests_ as $testIndex) {
      $testIndex->show();
    }      
  }   

  function debug($msg) {
    $debug_ = new Debug();
    $debug_->println("test_multiple-choice-meta.php",$msg);
  }

  function debug_r($msg) {
    $debug_ = new Debug();
    $debug_->println_r("test_multiple-choice-meta.php",$msg);
  }    



  function test_set() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $id = "123";   
    $question_id = "1";
    $letter = "a";
    $choice = "more then 100";
    

    $b = new MultipleChoiceMeta();
    $b->set($id,$question_id,$letter,$choice);

    $testcase = new Testcase("MultipleChoiceMeta.set()");

    $descr = "set(), checking id";
    $isSame = (strcmp($id,$b->id_) == 0);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking question id";
    $isSame = (strcmp($question_id,$b->question_id_) == 0);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking letter";
    $isSame = (strcmp($letter,$b->letter_) == 0);
    $ans = $b->letter_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "set(), checking choice";
    $isSame = (strcmp($choice,$b->choice_) == 0);
    $ans = $b->choice_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }

  function test_is() {

    $passed = $this->passed_;
    $failed = $this->failed_;
   
    $question_id = "1";
    $letter = "a";
    $choice = "more then 100";

    $question_id_bad = "-1";
    $letter_bad = "z";
    $choice_bad = "more then abc";    

    $testcase = new Testcase("MultipleChoiceMeta.is()");

    $descr = "Check for a null Question";
    $a = new MultipleChoiceMeta();
    $id = "";
    $ans = $a->is($id);
    $result = ($id == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Check for a 0 Question";
    $a = new MultipleChoiceMeta();
    $id = 0;
    $ans = $a->is($id);
    $result = ($id == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $a = new MultipleChoiceMeta();
    $id = $a->save($question_id,$letter,$choice);
    $descr = "Cheking  newly created Question exists";
    $ans = $id;
    $result = ($a->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);   

    
    $descr = "Checking deleted Question does not exist";
    $ans = $a->delete($id);
    $result = ($a->is($id) == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $a = new MultipleChoiceMeta();
    $id = $a->save($question_id_bad,$letter_bad,$choice_bad);
    $descr = "Cheking invlalid question_id not created";
    $ans = $id;
    $result = (!$a->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);  

    return $testcase;

  }    

  function test_load() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new MultipleChoiceMeta();

    $letter = "a";
    $choice = "more then 100";


    
    
    $testcase = new Testcase("MultipleChoiceMeta.load(id)");

    $a = new MultipleChoiceMeta();
    $id = -1;
    $isLoadOkay = $a->load($id);

    $descr = "Loading Bad Multiple Choice";
    $ans = $isLoadOkay;
    $result = (!$meta->is($id) && $isLoadOkay == false) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $question_meta = new QuestionMeta();
    $descr = "Creating new Question";
    $question_meta = new QuestionMeta();
    $question_id = $question_meta->save("a","b");
    $ans = $question_id;
    $result = ($question_meta->is($question_id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Creating new Multiple Choice ($question_id,$letter,$choice))";
    $a = new MultipleChoiceMeta();
    $id2 = $a->save($question_id,$letter,$choice);
    $ans = $id2;
    $result = ($meta->is($id2)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Loading Multiple Choice ($id)";
    $b = new MultipleChoiceMeta();
    $id = $b->load($id2);
    $ans = $id2;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking id";
    $isSame = (strcmp($id,$b->id_) == 0);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking question_id";
    $isSame = (strcmp($question_id,$b->question_id_) == 0);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking letter";
    $isSame = (strcmp($letter,$b->letter_) == 0);
    $ans = $b->letter_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking choice";
    $isSame = (strcmp($choice,$b->choice_) == 0);
    $ans = $b->choice_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Removing Question and multiple choice";  
    $meta->delete($id);
    $question_meta->delete($question_id);
    $ans = (! $meta->is($id) && ! $question_meta->is($question_id)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);
   
    return $testcase;
  }  


  function test_save() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $letter = "a";
    $choice = "more then 100";

    $meta = new MultipleChoiceMeta();

    $testcase = new Testcase("MultipleChoiceMeta.save()");

    $question_meta = new QuestionMeta();
    $descr = "Creating new Question";
    $question_meta = new QuestionMeta();
    $question_id = $question_meta->save("a","b");
    $ans = $question_id;
    $result = ($question_meta->is($question_id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $a = new MultipleChoiceMeta();
    $descr = "Creating Multiple Choice ($question_id,$letter,$choice)";
    $id = $a->save($question_id,$letter,$choice);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr= "Saving that Multiple Choice again";  
    $id2 = $a->save($question_id,$letter,$choice);
    $ans = $id2;
    $result = ($meta->is($id2) && $id != $id2) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Removing the Questions and Multiple Choices";  
    $meta->delete($id);
    $meta->delete($id2);
    $question_meta->delete($question_id);
    $ans = (! $meta->is($id) && ! $meta->is($id2) && !$question_meta->is($question_id)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }  


  function test_update() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new MultipleChoiceMeta();

    $letter = "a";
    $choice = "more then 100";

    $letter2 = "b";
    $choice2 = "less then 100";

    $testcase = new Testcase("MultipleChoiceMeta.update()");

    $question_meta = new QuestionMeta();
    $descr = "Creating new Question 1";
    $question_id = $question_meta->save("a","b");
    $ans = $question_id;
    $result = ($question_meta->is($question_id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Creating new Question 2";
    $question_id2 = $question_meta->save("e","f");
    $ans = $question_id2;
    $result = ($question_meta->is($question_id2)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $b = new MultipleChoiceMeta();
    $descr = "Creating Multiple Choice ($question_id,$letter,$choice)";
    $id = $b->save($question_id,$letter,$choice);
    $id = $b->load($id);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    

    $descr = "Multiple Choice ($id), checking id";
    $isSame = (strcmp($id,$b->id_) == 0);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking question_id";
    $isSame = (strcmp($question_id,$b->question_id_) == 0);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking letter";
    $isSame = (strcmp($letter,$b->letter_) == 0);
    $ans = $b->letter_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id), checking choice";
    $isSame = (strcmp($choice,$b->choice_) == 0);
    $ans = $b->choice_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Updating Multiple Choice($question_id2,$letter2,$choice2)";
    $b->update($id,$question_id2,$letter2,$choice2);
    $b = new MultipleChoiceMeta();
    $id2 = $b->load($id);
    $ans = $id2;
    $result = ($meta->is($id2) && $id2 == $id) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Updated Multiple Choice ($id2), checking id";
    $isSame = (strcmp($id2,$b->id_) == 0);
    $ans = $b->id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id2), checking question_id";
    $isSame = (strcmp($question_id2,$b->question_id_) == 0);
    $ans = $b->question_id_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id2), checking letter";
    $isSame = (strcmp($letter2,$b->letter_) == 0);
    $ans = $b->letter_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Multiple Choice ($id2), checking choice";
    $isSame = (strcmp($choice2,$b->choice_) == 0);
    $ans = $b->choice_;
    $result = ($isSame) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Removing Questions and multiple choice";  
    $meta->delete($id);
    $meta->delete($id2);
    $question_meta->delete($question_id);
    $question_meta->delete($question_id2);
    $ans = (! $meta->is($id) && ! $meta->is($id2) && !$question_meta->is($question_id) && !$question_meta->is($question_id2)) ;
    $result = ($ans) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }  


  function test_delete() {


    $passed = $this->passed_;
    $failed = $this->failed_;

    $meta = new MultipleChoiceMeta();

    $letter = "a";
    $choice = "more then 100";

    $testcase = new Testcase("MultipleChoiceMeta.delete()");

    $question_meta = new QuestionMeta();
    $descr = "Creating new Question";
    $question_id = $question_meta->save("a","b");
    $ans = $question_id;
    $result = ($question_meta->is($question_id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $b = new MultipleChoiceMeta();
    
    $descr = "Creating Multiple Choice ($question_id,$letter,$choice)";
    $id = $b->save($question_id,$letter,$choice);
    $ans = $id;
    $result = ($meta->is($id)) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);


    $descr = "Deleting Question($id)";
    $b = new MultipleChoiceMeta();
    $b->delete($id);
    $question_meta->delete($question_id);
    $ans = $id;
    $result = (!$meta->is($id) && !$question_meta->is($question_id) ) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;    

  }   

  
}


?>