
<?

require_once("../_php/root.php");

global $root;

require_once($root->pathToTools() . "testcase.php");

if ($root->page() == "test_root.php") {
  $test = new RootTest();
  $test->runAll();
}    

class RootTest {

  var $passed_;
  var $failed_;
  var $title_;
  var $page_;

  var $tests_;
  

  function RootTest($page="test_root.php",$title = "RootTest") {

    $testcase = new TestCase();

    $this->passed_ = $testcase->passed();
    $this->failed_ = $testcase->failed();

    $this->tests_ = Array();
    $this->title_ = $title;
  }    

  function doAll() {
    $this->tests_[0] = $this->test_makePathTo();
    $this->tests_[1] = $this->test_pathTo();
    $this->tests_[2] = $this->test_pathFrom();
    return $this->tests_;
  }    

  function runAll() {

    global $root;


    echo "You are working on: " . $root->box_["name"] . " <br>";
    echo "The current path is $root->path_ <br><br>";
    
    $this->doAll();
    $testcase = new TestCase($this->title_);
    $testcase->intro($this->title_);
    foreach ($this->tests_ as $testIndex) {
      $testIndex->show();
    }      
  }   


  function test_makePathTo() {

    global $root;

    $passed = $this->passed_;
    $failed = $this->failed_;

    $testcase = new Testcase("makePathToRoot()");

    $descr = "At Root check";
    $ans = $root->makePathTo(0);
    $expected = "";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $descr = "Go back 1";
    $ans = $root->makePathTo(1);
    $expected = "../";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);
    

    $descr  = "Go back 5";
    $ans= $root->makePathTo(5);
    $expected = "../../../../../";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }

  function test_pathTo() {

    global $root;

    $passed = $this->passed_;
    $failed = $this->failed_;

    $testcase = new Testcase("getPathToRoot()");


    $root->box_["root"] = "/" . $root->box_["dir"] . "/_testsuite/";
    $descr = $root;
    $ans = $root->pathTo();
    $expected = "";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);
    
    $root->box_["root"] = "/" . $root->box_["dir"] . "/";
    $descr = $root;
    $ans = $root->pathTo();
    $expected = "../";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    return $testcase;

  }


  function test_pathFrom() {

    $passed = $this->passed_;
    $failed = $this->failed_;

    global $root;

    $testcase = new Testcase("getPathFromRoot()");


    $descr = "Check default";
    $ans = $root->pathFrom();
    $expected = "_testsuite/";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $root->box_["root"] = "/" . $root->box_["dir"] . "/_testsuite/";
    $descr =  $root->box_["root"]; 
    $ans = $root->pathFrom();
    $expected = "";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $root->box_["root"] = "/" . $root->box_["dir"] . "/";
    $descr =  $root->box_["root"]; 
    $ans = $root->pathFrom();
    $expected = "_testsuite/";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $root->box_["root"] = "/";
    $descr =  $root->box_["root"]; 
    $ans = $root->pathFrom();
    $expected = $root->box_["dir"]. "/_testsuite/";
    $result = ($ans == $expected) ? $passed : $failed;
    $testcase->add($descr,$ans,$result);

    $root->box_["root"] = "/" . $root->box_["dir"] . "/";

    return $testcase;
    
  }    


  //```````````````````````
  // DEBUGGING
  //```````````````````````

  function debug($msg) {
    $debug = new Debug();
    $debug->println("test_root.php",$msg);
  }    

  function debug_r($msg) {
    $debug = new Debug();
    $debug->println_r("test_root.php",$msg);
  }    

  function alertSql($msg) {
    $debug = new Debug();
    $debug->alertSql("test_root.php",$msg);  
  } 



}  











?>